<template>
  <h1>Icons</h1>

  <div class="_filters">
    <div class="_filters__section">
      <div class="_filters__section__title">Search</div>
      <input v-model="searchTerm" type="search">
    </div>
    <div class="_filters__section">
      <div class="_filters__section__title">Size</div>
      <select v-model="size">
        <option value="" />
        <option v-for="val in sizes" :key="val" :value="val">{{ val }}</option>
      </select>
    </div>
  </div>

  <div class="-mtd">
    <div v-for="icon in icons" :key="icon" class="-flex -gap">
      <rui-icon :name="icon" :size="size" />
      <code>{{ icon }}</code>
    </div>
  </div>
</template>

<script>
import RuiIcon from '@experiments-labs/rise_ui/src/components/Icon/Icon.vue'

import rawIcons from '../../../../app/assets/images/icons.svg?raw'

const parser = new DOMParser()
const iconElement = parser.parseFromString(rawIcons, 'image/svg+xml')

const icons = Array.from(iconElement.querySelectorAll('symbol'))
  .map(e => e.id.replace(/^icon-/, ''))
  .sort()

export default {
  components: { RuiIcon },
  data () {
    return {
      searchTerm: '',
      size: null,
      sizes: [3, 4, 10],
    }
  },
  computed: {
    icons () {
      const searchTerm = this.searchTerm.trim()
      if (searchTerm === '') return icons

      return icons.filter(i => i.includes(searchTerm))
    },
  },
  created () {
    this.$setTitle('Icons')
  },
}
</script>
